<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Eddie: /builds/eclipse/oniro-core/eddie/linux/communication/include/CoapClient.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Eddie
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_88e6415a3128b404f1102a130772bdb6.html">linux</a></li><li class="navelem"><a class="el" href="dir_9d6112f7740eb6b19e6896a373a5986f.html">communication</a></li><li class="navelem"><a class="el" href="dir_046dfdec3fa9891163197d92ca19a5c8.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">CoapClient.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * SPDX-License-Identifier: Apache-2.0</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * SPDX-FileCopyrightText: Huawei Inc.</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * SPDX-FileCopyrightText: Politecnico Di Milano</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef EDDIE_COAPCLIENT_H</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define EDDIE_COAPCLIENT_H</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;common.h&quot;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;eddie.h&quot;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;coap3/coap.h&gt;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;condition_variable&gt;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;thread&gt;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#define COAP_IP4_MULTICAST &quot;224.0.1.187&quot;</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#define COAP_IP6_MULTICAST_LOCAL_LINK &quot;FF02::FD&quot;</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#define COAP_IP6_MULTICAST_SITE_LOCAL &quot;FF05::FD&quot;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160; </div>
<div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="classCoapClient.html">   24</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCoapClient.html">CoapClient</a> {</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keywordtype">bool</span> quit = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    coap_context_t *context = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    coap_session_t *open_session(<span class="keyword">const</span> <span class="keywordtype">char</span> *dst_host, <span class="keyword">const</span> <span class="keywordtype">char</span> *dst_port);</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keyword">static</span> <a class="code" href="classThreadSafeMap.html">ThreadSafeMap&lt;std::string, message_t&gt;</a> *messages;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    std::string last_token;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    std::thread client_thread;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keyword">static</span> std::mutex client_mutex;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keyword">static</span> std::condition_variable client_condition;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160; </div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordtype">void</span> set_quit(<span class="keywordtype">bool</span> value);</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    [[nodiscard]] <span class="keywordtype">bool</span> get_quit() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keyword">static</span> coap_response_t</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    message_handler(coap_session_t *session, <span class="keyword">const</span> coap_pdu_t *sent, <span class="keyword">const</span> coap_pdu_t *received,</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;                    coap_mid_t <span class="keywordtype">id</span>);</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div>
<div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="classCoapClient.html#a5e8009df16efede98c4f750bd21b59e1">   55</a></span>&#160;    <span class="keyword">explicit</span> <a class="code" href="classCoapClient.html#a5e8009df16efede98c4f750bd21b59e1">CoapClient</a>(coap_context_t *context = <span class="keyword">nullptr</span>);</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="classCoapClient.html#af4751a8eb83688c71b56cd1f24b9975a">   60</a></span>&#160;    <a class="code" href="classCoapClient.html#af4751a8eb83688c71b56cd1f24b9975a">~CoapClient</a>();</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; </div>
<div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="classCoapClient.html#a6db00b55c5437b1b239f59c5d1e7ae3a">   67</a></span>&#160;    std::string <a class="code" href="classCoapClient.html#a6db00b55c5437b1b239f59c5d1e7ae3a">send_message</a>(<a class="code" href="structrequest__t.html">request_t</a> request);</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160; </div>
<div class="line"><a name="l00076"></a><span class="lineno"><a class="line" href="classCoapClient.html#ab7a5adf34c482801d427851ef846e53c">   76</a></span>&#160;    <span class="keyword">static</span> <a class="code" href="structmessage__t.html">message_t</a> <a class="code" href="classCoapClient.html#ab7a5adf34c482801d427851ef846e53c">receive_message</a>(std::string token, <span class="keywordtype">int</span> timeout=5);</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div>
<div class="line"><a name="l00085"></a><span class="lineno"><a class="line" href="classCoapClient.html#aaa0f931079f33fda874caf691fd2c3f3">   85</a></span>&#160;    <a class="code" href="structmessage__t.html">message_t</a> <a class="code" href="classCoapClient.html#aaa0f931079f33fda874caf691fd2c3f3">send_message_and_wait_response</a>(<a class="code" href="structrequest__t.html">request_t</a> request, <span class="keywordtype">int</span> timeout=5);</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;};</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160; </div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="preprocessor">#endif </span><span class="comment">//EDDIE_COAPCLIENT_H</span></div>
<div class="ttc" id="aclassCoapClient_html"><div class="ttname"><a href="classCoapClient.html">CoapClient</a></div><div class="ttdef"><b>Definition:</b> CoapClient.h:24</div></div>
<div class="ttc" id="aclassCoapClient_html_a5e8009df16efede98c4f750bd21b59e1"><div class="ttname"><a href="classCoapClient.html#a5e8009df16efede98c4f750bd21b59e1">CoapClient::CoapClient</a></div><div class="ttdeci">CoapClient(coap_context_t *context=nullptr)</div></div>
<div class="ttc" id="aclassCoapClient_html_a6db00b55c5437b1b239f59c5d1e7ae3a"><div class="ttname"><a href="classCoapClient.html#a6db00b55c5437b1b239f59c5d1e7ae3a">CoapClient::send_message</a></div><div class="ttdeci">std::string send_message(request_t request)</div></div>
<div class="ttc" id="aclassCoapClient_html_aaa0f931079f33fda874caf691fd2c3f3"><div class="ttname"><a href="classCoapClient.html#aaa0f931079f33fda874caf691fd2c3f3">CoapClient::send_message_and_wait_response</a></div><div class="ttdeci">message_t send_message_and_wait_response(request_t request, int timeout=5)</div></div>
<div class="ttc" id="aclassCoapClient_html_ab7a5adf34c482801d427851ef846e53c"><div class="ttname"><a href="classCoapClient.html#ab7a5adf34c482801d427851ef846e53c">CoapClient::receive_message</a></div><div class="ttdeci">static message_t receive_message(std::string token, int timeout=5)</div></div>
<div class="ttc" id="aclassCoapClient_html_af4751a8eb83688c71b56cd1f24b9975a"><div class="ttname"><a href="classCoapClient.html#af4751a8eb83688c71b56cd1f24b9975a">CoapClient::~CoapClient</a></div><div class="ttdeci">~CoapClient()</div></div>
<div class="ttc" id="aclassThreadSafeMap_html"><div class="ttname"><a href="classThreadSafeMap.html">ThreadSafeMap&lt; std::string, message_t &gt;</a></div></div>
<div class="ttc" id="astructmessage__t_html"><div class="ttname"><a href="structmessage__t.html">message_t</a></div><div class="ttdef"><b>Definition:</b> eddie.h:74</div></div>
<div class="ttc" id="astructrequest__t_html"><div class="ttname"><a href="structrequest__t.html">request_t</a></div><div class="ttdef"><b>Definition:</b> eddie.h:62</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
